var BROSJSBridge = new BROSJSBridgeImpl();
var callBackMap = new BROSMap();
function BROSJSBridgeImpl() {
   
    function makeCallback(params) {
        for (var key in params) {
            var item = params[key];
            if (typeof item == 'function') {
                var rnd = Math.random().toString(36).substr(2);
                var callbackName = "callback_"+rnd;
                window[callbackName] = (function (fn, callbackName) {
                    return function (res) {
                        fn(res);
                    }
                })(item, callbackName);
                params[key] = callbackName;
            } else if (typeof item == 'object') {
                params[key] = makeCallback(item)
            }
        }
        return params;
    }

 this.invoke = function (funcName, paramObj, callback) {
        if (!callback) {
            console.info("H5>>>>>Native callback null");
        } else {
            if (typeof callback != "function") {
				throw new Error("'callback' must be a function: " + callback);
			}
		}
		var localCallbackId = "BROS_" + Math.random().toString(36).substr(2);
		callBackMap.put(localCallbackId, callback);
		JSBridge.invoke(funcName, JSON.stringify(makeCallback(paramObj)), localCallbackId);
	};
	window.BROSJSBridge = BROSJSBridge;
	window.callBackMap = callBackMap;
}

function onCallback(res) {
    try {
        var callbackId = res.callbackId;
        var callback = window.callBackMap.get(callbackId);
        if (callback != null) {
            callback(res);
            return;
        } else {
            console.log("callbackMap: " + JSON.stringify(window.callBackMap));
        }

    } catch (err) {
        console.log("onCallback err: " + err.message);
    }
}


function handleCreateFunction() {
    try {
        if (window.BROSJSBridge && typeof window.BROSJSBridge.invoke == "function" && window._cl_tracker) {
            var identityType = null;
            var identityValue = null;
            window.BROSJSBridge.invoke('get_customer_identity', {}, function (res) {
                console.log(JSON.stringify(res));
                identityType = res.result.identityType.trim();
                identityValue = res.result.identityValue.trim();
                window._cl_tracker.push({ "identityType": identityType, "identityValue": identityValue });
                window._cl_tracker.track('c_app_openpage', {});
            });
        }

        var readyEvent = document.createEvent("Events");
        readyEvent.initEvent("BROSJSBridgeReady");
        document.dispatchEvent(readyEvent);
    } catch (err) {
        console.log("onInit err: " + err.message);
    }
}

function BROSMap() {
    this.map = {};
    this.length = 0;
    this.size = function () {
        return this.length;
    };
    this.put = function (a, b) {
        if (!this.map["_" + a]) {
            ++this.length;
        }
        this.map["_" + a] = b;
    };
    this.remove = function (a) {
        if (this.map["_" + a]) {
            --this.length;
            return delete this.map["_" + a];
        } else {
            return false;
        }
    };
    this.containsKey = function (a) {
        return this.map["_" + a] ? true : false;
    };
    this.get = function (a) {
        return this.map["_" + a] ? this.map["_" + a] : null;
    };
    this.toString = function () {
        var b = "";
        for (var a in this.map) {
            b += "\n" + a + "-" + this.map[a];
        }
        return b;
    };
}